std::floor,std::floorf,std::floorl(3)

NAME
std::floor,std::floorf,std::floorl - std::floor,std::floorf,std::floorl

Synopsis
   Defined in header <cmath>
   float floor ( float arg ); (1) (constexpr since C++23)
   float floorf( float arg ); (2) (since C++11)
                        (constexpr since C++23)
   double floor ( double arg ); (3) (constexpr since C++23)
   long double floor ( long double arg ); (4) (constexpr since C++23)
   long double floorl( long double arg ); (5) (since C++11)
                        (constexpr since C++23)
   double floor ( IntegralType arg ); (6) (since C++11)
                        (constexpr since C++23)
   1-5) Computes the largest integer value not greater than arg.
   6) A set of overloads or a function template accepting an argument of any integral
   type. Equivalent to (3) (the argument is cast to double).

Parameters
   arg - floating point value

Return value
   If no errors occur, the largest integer value not greater than arg, that is
   ⌊arg⌋, is returned.

Return value
   math-floor.svg
   Argument

Error handling
   Errors are reported as specified in math_errhandling.
   If the implementation supports IEEE floating-point arithmetic (IEC 60559),
     * The current rounding mode has no effect.
     * If arg is ±∞, it is returned, unmodified
     * If arg is ±0, it is returned, unmodified
     * If arg is NaN, NaN is returned

Notes
   FE_INEXACT may be (but isn't required to be) raised when rounding a non-integer
   finite value.
   The largest representable floating-point values are exact integers in all standard
   floating-point formats, so this function never overflows on its own; however the
   result may overflow any integer type (including std::intmax_t), when stored in an
   integer variable.

Example
// Run this code
 #include <cmath>
 #include <iostream>
 int main()
 {
     std::cout << std::fixed
               << "floor(+2.7) = " << std::floor(+2.7) << '\n'
               << "floor(-2.7) = " << std::floor(-2.7) << '\n'
               << "floor(-0.0) = " << std::floor(-0.0) << '\n'
               << "floor(-Inf) = " << std::floor(-INFINITY) << '\n';
 }

Output:
 floor(+2.7) = 2.000000
 floor(-2.7) = -3.000000
 floor(-0.0) = -0.000000
 floor(-Inf) = -inf

See also
   ceil
   ceilf nearest integer not less than the given value
   ceill (function)
   (C++11)
   (C++11)
   trunc
   truncf
   truncl nearest integer not greater in magnitude than the given value
   (C++11) (function)
   (C++11)
   (C++11)
   round
   roundf
   roundl
   lround
   lroundf
   lroundl
   llround
   llroundf
   llroundl nearest integer, rounding away from zero in halfway cases
   (C++11) (function)
   (C++11)
   (C++11)
   (C++11)
   (C++11)
   (C++11)
   (C++11)
   (C++11)
   (C++11)